/**
 * Fichero : abdb.c      Fecha:16/02/2019
 * Autores:                                   
 *                                            
 *  fichero con la implementacion del TAD Arbol Binario de Busqueda
 *                                            
 */

#include <stdlib.h>
#include <stdio.h>

#include "abdb.h"


/**
 * Funcion para crear una nueva estructura de abdb que no hace nada
 *
 * Entrada:
 *
 * Salida:
 *    devuelve siempre NULL
 *
 */
Arbol crearArbol()
{
  return NULL;
}

/**
 * Funcion para liberar la memoria reservada del arbol. Se debe hacer de forma
 * recursiva
 *
 * Entrada:
 *    Estructura arbol a liberar
 */
void borrarArbol(Arbol A)
{
}

/**
 * Funcion para crear un nuevo nodo
 *
 * Entrada:
 *    Dato a asignar al nodo
 *
 * Salida:
 *    devuelve el nodo del arbol inicializado o NULL
 *    si hay algun error
 *
 */
Arbol crearNodo(int X)
{
  Arbol a;

  a = (Arbol) malloc(sizeof(Nodoa));

  if (a == NULL) {
    return NULL;
  }
  else {
    a->dato = X;
    a->izqdo = a->dcho = NULL;
    return a;
  }
}

/**
 * Funcion para insertar un dato en el arbol
 *
 * Entrada:
 *    Dato a insertar
 *    Estructura arbol donde se inserta el nodo
 *
 * Salida:
 *    El nodo del arbol con el nuevo nodo creado o NULL si da error
 */
Arbol insertarDato(int X, Arbol A)
{
  if (A == NULL)
    A = crearNodo(X);
  else
    if (X < A->dato)
      A->izqdo = insertarDato(X,A->izqdo);
    else if (X > A->dato)
      A->dcho = insertarDato(X,A->dcho);

  return A;
}

/**
 * Funcion para buscar un elemento determinado en el arbol
 *
 * Entrada:
 *    Estructura arbol a recorrer
 *    Dato a buscar
 *
 * Salida:
 *    1 si encuentra el dato y 0 si no lo encuentra
 */
int buscar(int X, Arbol A)
{
  if (A == NULL)    return 0;
  if (X == A->dato) return 1;
  if (X < A->dato)  return buscar(X,A->izqdo);

  return buscar(X,A->dcho);
}

/**
 * Funcion para recorrer el arbol en profundidad en orden
 *
 * Entrada:
 *    Estructura arbol a recorrer
 *    Lista donde se devuelven los elementos ordenados
 * Salida:
 *    Booleano indicando si todo ha ido bien o no
 */
void enorden(Arbol raiz)
{
  if(raiz) {
    enorden(raiz->izqdo);
    printf("%d\n",raiz->dato);
    enorden(raiz->dcho);
  }
}

/**
 * Funcion para buscar el mínimo del arbol 
 *
 * Entrada:
 *    Estructura arbol a recorrer
 *
 * Salida:
 *    PNodoa con el dato minimo
 */
PNodoa encontrar_min(Arbol A)
{
}

/**
 * Funcion para liberar la memoria reservada de la estructura abdb
 *
 * Entrada:
 *    Estructura arbol a liberar
 */
Arbol borrarDato(int X, Arbol A)
{
}

  
