/**
 * Fichero : abdb.h      Fecha:16/02/2019
 * Autores:                                   
 *                                            
 *  fichero con la cabecera del TAD Arbol Binario de Busqueda
 *                                            
 */

#ifndef __ABDB_H_
#define __ABDB_H_

typedef struct  Nodoa *PNodoa;
typedef struct  Nodoa *Arbol;

typedef struct Nodoa {
	int dato;
	Arbol izqdo;
	Arbol dcho;
} Nodoa;

/**
 * Funcion para crear una nueva estructura de abdb que no hace nada
 *
 * Entrada:
 *
 * Salida:
 *    devuelve siempre NULL
 *
 */
Arbol crearArbol();

/**
 * Funcion para liberar la memoria reservada del arbol
 *
 * Entrada:
 *    Estructura arbol a liberar
 */
void borrarArbol(Arbol A);

/**
 * Funcion para insertar un dato en el arbol
 *
 * Entrada:
 *    Dato a insertar
 *    Estructura arbol donde se inserta el nodo
 *
 * Salida:
 *    El nodo del arbol con el nuevo nodo creado o NULL si da error
 */
Arbol insertarDato(int X, Arbol A);

/**
 * Funcion para recorrer el arbol en profundidad en orden
 *
 * Entrada:
 *    Estructura arbol a recorrer
 *    Lista donde se devuelven los elementos ordenados
 * Salida:
 *    Booleano indicando si todo ha ido bien o no
 */
void enorden(Arbol raiz);

/**
 * Funcion para buscar un elemento determinado en el arbol
 *
 * Entrada:
 *    Estructura arbol a recorrer
 *    Dato a buscar
 *
 * Salida:
 *    1 si encuentra el dato y 0 si no lo encuentra
 */
int buscar(int X, Arbol A);

/**
 * Funcion para buscar el mínimo del arbol 
 *
 * Entrada:
 *    Estructura arbol a recorrer
 *
 * Salida:
 *    PNodoa con el dato minimo
 */
PNodoa encontrar_min(Arbol A);

/**
 * Funcion para liberar la memoria reservada de la estructura abdb
 *
 * Entrada:
 *    Estructura arbol a liberar
 */
Arbol borrarDato(int X, Arbol A);

#endif



