#include <stdlib.h>
#include <stdio.h>
#include "avl.h"

/* Funciones auxiliares */

int max(int a, int b)
{
  return a < b ? b : a;
}

/**
 * Funcion para crear una nueva estructura de abdb que no hace nada
 *
 * Entrada:
 *
 * Salida:
 *    devuelve siempre NULL
 *
 */
AVL crearAVL()
{
  return NULL;
}

/**
 * Funcion para liberar la memoria reservada del arbol AVL
 *
 * Entrada:
 *    Estructura arbol a liberar
 */
void borrarAVL(AVL A)
{
}

/**
 * Funcion que devuelve la altura de un nodo del arbol AVL
 *
 * Entrada:
 *    Estructura nodo
 */
int altura(PNodoAVL N)
{
	if (N == NULL)
		return -1;
	else
		return N->altura;
}

/**
 * Funcion para crear un nuevo nodo
 *
 * Entrada:
 *    Dato a asignar al nodo
 *
 * Salida:
 *    devuelve el nodo del arbol inicializado o NULL
 *    si hay algun error
 *
 */
AVL crearNodoAVL(int X)
{
	PNodoAVL a;

	a = (PNodoAVL) malloc(sizeof(NodoAVL));

	if (a == NULL) {
		return NULL;
	}
	else {
		a->dato = X;
		a->izqdo = a->dcho = NULL;
		a->altura = 0;
		return a;
	}
}

/**
 * Funcion para realizar una rotación simple derecha
 *
 * Entrada:
 *    Nodo sobre el que se aplica la rotación
 *
 * Salida:
 *    devuelve el nodo del arbol que se situa donde esta el nodo R
 *
 */
PNodoAVL rotacionSD(PNodoAVL R)
{
	PNodoAVL X;

	X = R->izqdo;
	R->izqdo = X->dcho;
	X->dcho = R;

	R->altura = max(altura(R->izqdo),altura(R->dcho)) + 1;
	X->altura = max(altura(X->izqdo),R->altura) + 1;

	return X;
}

/**
 * Funcion para realizar una rotación simple izquierda
 *
 * Entrada:
 *    Nodo sobre el que se aplica la rotación
 *
 * Salida:
 *    devuelve el nodo del arbol que se situa donde esta el nodo R
 *
 */
PNodoAVL rotacionSI(PNodoAVL R)
{
}

/**
 * Funcion para realizar una doble derecha
 *
 * Entrada:
 *    Nodo sobre el que se aplica la rotación
 *
 * Salida:
 *    devuelve el nodo del arbol que se situa donde esta el nodo R
 *
 */
PNodoAVL rotacionDD(PNodoAVL R)
{
}

/**
 * Funcion para realizar una doble izquierda
 *
 * Entrada:
 *    Nodo sobre el que se aplica la rotación
 *
 * Salida:
 *    devuelve el nodo del arbol que se situa donde esta el nodo R
 *
 */
PNodoAVL rotacionDI(PNodoAVL R)
{
}

/**
 * Funcion para insertar un dato en el arbol
 *
 * Entrada:
 *    Dato a insertar
 *    Estructura arbol donde se inserta el nodo
 *
 * Salida:
 *    El nodo del arbol con el nuevo nodo creado o NULL si da error
 */
AVL insertarAVL(int X, AVL A)
{
	if (A == NULL)
		A = crearNodoAVL(X);
	else if (X < A->dato) {
		A->izqdo = insertarAVL(X,A->izqdo);
		if (altura(A->izqdo) - altura(A->dcho) == 2) {
			if (X < A->izqdo->dato) {
				A = rotacionSD(A);
      }
			else {
				A = rotacionDD(A);
      }
    }
	}
	else if (X > A->dato) {
		A->dcho = insertarAVL(X,A->dcho);
		if (altura(A->dcho) - altura(A->izqdo) == 2) {
			if (X > A->dcho->dato) {
				A = rotacionSI(A);
      }
			else {
				A = rotacionDI(A);
      }
    }
	}
	A->altura = max(altura(A->izqdo),altura(A->dcho)) + 1;
	return A;
}

