/**
 * Fichero : avl.h      Fecha:16/02/2019
 * Autores:                                   
 *                                            
 *  fichero con la cabecera del TAD AVL AVL
 *                                            
 */

#ifndef __AVL_H_
#define __AVL_H_

typedef struct NodoAVL *PNodoAVL;
typedef struct NodoAVL *AVL;

typedef struct NodoAVL {
	int dato;
	AVL izqdo;
	AVL dcho;
	int altura;
} NodoAVL;

/**
 * Funcion para crear una nueva estructura de abdb que no hace nada
 *
 * Entrada:
 *
 * Salida:
 *    devuelve siempre NULL
 *
 */
AVL crearAVL();

/**
 * Funcion para liberar la memoria reservada del arbol AVL
 *
 * Entrada:
 *    Estructura arbol a liberar
 */
void borrarAVL(AVL A);

/**
 * Funcion que devuelve la altura de un nodo del arbol AVL
 *
 * Entrada:
 *    Estructura nodo
 */
int altura(PNodoAVL N);

/**
 * Funcion para insertar un dato en el arbol
 *
 * Entrada:
 *    Dato a insertar
 *    Estructura arbol donde se inserta el nodo
 *
 * Salida:
 *    El nodo del arbol con el nuevo nodo creado o NULL si da error
 */
AVL insertarAVL(int X, AVL A);

#endif

